﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.5
@EndOfDesignText@
#DesignerProperty: Key: BooleanExample, DisplayName: Show Seconds, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color
#Event: ExampleEvent (Value As Int)

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
#if b4i
	Public mBase As Panel
#else
	Public mBase As B4XView
#end if

	Private xui As XUI 'ignore
	Public Tag As Object
	Private IsReady As Boolean

	'Speedpilot
	Private pnlMidle As Panel
	Private pnlL(10) As Panel
	Private pnlR(10) As Panel
	Private pnlLzs(9) As Panel ' Zentelsekunden
	Private pnlRzs(9) As Panel ' Zentelsekunden
	Private AvarageSpeedColor As Int
	Private DeviationDistanceColor As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
	mBase.Tag = Me
	
	CallSubDelayed3(Me, "AfterLoadLayout", Lbl, Props)
End Sub

Private Sub AfterLoadLayout(Lbl As Label, Props As Map) 'ignore
	mBase.LoadLayout("layspeedbar")
		
	#if b4i
'		lblClock.Font = Lbl.Font
'		timer1.Initialize("timer1", 1000)
'		timer1.Enabled = True
'		TextResizer.Initialize(mBase)
	'ResizeLabelText
	#else
		'ResizeLabelText
	#end if
	InitSpeedbar
	
	IsReady = True
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	If IsReady Then
		'ResizeLabelText
	End If
End Sub

private Sub InitSpeedbar

	pnlMidle = mBase.GetView(0)
	'Sekunden
	For i = 1 To 10
		pnlL(i - 1) = mBase.GetView(i)
	Next
	For i = 11 To 20
		pnlR(i - 11) = mBase.GetView(i)
	Next

	'Zentelnsekunden
	For i = 21 To 29
		pnlLzs(i - 21) = mBase.GetView(i)
	Next
	For i = 30 To 38
		pnlRzs(i - 30) = mBase.GetView(i)
	Next

	ResetSpeedbarColor
End Sub

Private Sub ResetSpeedbarColor
	pnlMidle.Color = Colors.ARGB(50,0,255,0) 'Lime
	If pnlL(0).IsInitialized Then
		For i = 0 To 9
			pnlL(i).Color = Colors.ARGB(50,255,0,0) 'RED
			pnlR(i).Color = Colors.ARGB(50,255,255,0) 'Yellow
		Next
		For i = 0 To 8
			pnlLzs(i).Color = Colors.ARGB(50,255,0,0) 'RED
			pnlRzs(i).Color = Colors.ARGB(50,255,255,0) 'Yellow
		Next
	End If
End Sub

Private Sub SetSpeedbarColor(dbStep As Double)
	pnlMidle.Color = Colors.ARGB(255,0,255,0) 'Lime

	For i = 0 To 9
		pnlL(i).Color = Colors.ARGB(50,255,0,0) 'RED
		pnlR(i).Color = Colors.ARGB(50,255,255,0) 'Yellow
	Next
	For i = 0 To 8
		pnlLzs(i).Color = Colors.ARGB(50,255,0,0) 'RED
		pnlRzs(i).Color = Colors.ARGB(50,255,255,0) 'Yellow
	Next

	Dim intStep As Int = dbStep
	Dim intZsek As Int = Abs(Round2(dbStep - intStep, 2) * 10)
	Dim IsExit As Boolean
	
	If dbStep > 0 Then
		For i = 0 To Abs(intStep) -1
			If i < 10 Then
				pnlL(i).Color = Colors.ARGB(255,255,0,0) 'RED
			Else
				IsExit = True
				Exit
			End If
		Next
		If Not(IsExit) Then
			For i = 0 To Abs(intZsek) -1
				If i < 9 Then
					pnlLzs(i).Color = Colors.ARGB(255,255,0,0) 'RED
				End If
			Next
		End If
	else If dbStep < 0 Then
		For i = 0 To Abs(intStep) -1
			If i < 10 Then
				pnlR(i).Color = Colors.ARGB(255,255,255,0) 'Yellow
			Else
				IsExit = True
				Exit
			End If
		Next
		If Not(IsExit) Then
			For i = 0 To Abs(intZsek) -1
				If i < 9 Then
					pnlRzs(i).Color = Colors.ARGB(255,255,255,0) 'Yellow
				End If
			Next
		End If
	End If
End Sub

Public Sub ShowSpeedbar(status As Double)
	'Log("status=" & status)
	Dim intColor As Int
	
	If status = 0 Then
		ResetSpeedbarColor
		intColor = Colors.White
	Else If status > -0.1 And status < 0.1 Then
		ResetSpeedbarColor
		pnlMidle.Color = Colors.ARGB(255,0,255,0) 'Lime
		intColor = Colors.Green
	Else If status > 0 Then
		SetSpeedbarColor(status)
		intColor = Colors.red
	Else If status < -0 Then
		SetSpeedbarColor(status)
		intColor = Colors.Yellow
	End If
	AvarageSpeedColor = intColor
	DeviationDistanceColor = intColor
End Sub

Public Sub AvarageSpeedTextColor As Int
	Return AvarageSpeedColor
End Sub

Public Sub DeviationDistanceTextColor As Int
	Return DeviationDistanceColor
End Sub
#End Region

#if b4i
'Equivalent funktion von B4a
Private Sub Round2(Number As Double, DecimalPlaces As Int) As Double
	Private shift As Double = Power(10, DecimalPlaces)
	Return Round(Number * shift) / shift
End Sub
#end if